  /* Zadatak 10.1.8. (str. 113)

     Napisite funkciju koja prima jedan cjelobrojni parametar n iz Z,
     te vraca 1 ako je |n| prost, odnosno 0, ako |n| nije prost.

     Lose rjesenje - testiranjem djelitelja do n - 1.
     Bolje je ici do n/2, a jos bolje do (int) sqrt(n).
  */

#include <stdio.h>

int abs_is_prime(int n)
{
    int d;    /* Potencijalni djelitelj. */

        /* Apsolutna vrijednost broja. */
    if (n < 0) n = -n;

        /* Brojevi 0, 1 nisu prosti. */
    if (n <= 1) return 0;

        /* Testiraj sve moguce djelitelje od n.
           U ovoj (LOSOJ) varijanti, od 2 do n - 1. */

    d = 2;
    while (d < n) {
        if (n % d == 0) return 0;    /* Nije prost. */
        ++d;
    }
    return 1;
}

int main(void)
{
        /* Nadji najmanji prosti broj veci ili jednak od ucitanog n. */
    int n;

    printf(" Upisi broj n: ");
    scanf("%d", &n);
    printf("\n Trazim najmanji prosti broj >= %d\n", n);

    while (!abs_is_prime(n)) ++n;

    printf(" Trazeni prosti broj = %d\n", n);

    return 0;
}
